#  group.py
#
import random, sarg
from   common import Player, flipCoin, randomSeed

names = ['Alan', 'Betty', 'Charlie', 'Diane', 'Erica', 'Frank']
colors= [ 'red', 'green',    'blue','orange','yellow', 'purple']

def groupPlay() :
    players = [Player(names[i],colors[i]) for i in range(len(names))] 
    winRate  = sarg.Float("winRate", .20) # fraction player gets for win
    lossRate = sarg.Float("lossRate",.17) # fraction player pays for loss
    taxRate  = sarg.Float("taxRate", .00) # tax over $200 each transaction
    print("rates", winRate, lossRate)

    for j in range(sarg.Int("trades",500)):
        random.shuffle(players)
        isHeads = flipCoin(players[0], players[1], winRate, lossRate)
        wealthTax(players, taxRate)
        for player in players :   # for each player
            player.hist.append(round(player.money,2))
    ranking = [(p.money, p) for p in players]
    ranking.sort()
    for bal,player in reversed(ranking) :
        print("%8.02f  %-8s %s" % (bal, player.name, player.color))
    plotMoney(players)

def wealthTax(players,taxRate) :
    # if wealth exceed 200, tax the excess at the taxRate
    totTax = 0.0
    for player in players :
        tax = max(0., player.money-200)*taxRate
        totTax += tax
        player.money -= tax
    dist = totTax/len(players)    # spread evenly to all players
    for player in players : player.money += dist

def plotMoney(players) :
    import matplotlib.pyplot as plt
    plt.suptitle("Money over time", size=16)
    for player in players :
        xps = list(range(len(player.hist)))
        yps = player.hist
        plt.plot(xps,yps, player.color)
    plt.show()

if __name__ == "__main__" : 
    randomSeed() 
    groupPlay()
