#!/usr/local/bin/python
#
import random, sarg
from   common import Player, flipCoin, randomSeed

def singlePlay() :
    nFlips   = sarg.Int("flips",     20 )   # number of coin flips per game
    amt1     = sarg.Float("amt1",   100.)   # original player 1 amount
    amt2     = sarg.Float("amt2",  1000.)   # original player 2 amount
    winRate  = sarg.Float("winRate", .20)   # fraction player gets for win
    lossRate = sarg.Float("lossRate",.17)   # fraction player pays for loss

    chump = Player("Chump", "blue", amt1)
    house = Player("House", "red",  amt2)
    playGame(nFlips, chump, house, winRate, lossRate)

def playGame(nFlips, chump, house, winRate, lossRate) :
    print(" flip         %6s   %6s" % (house.name, chump.name))
    nHeads = 0
    for flip in range(nFlips) :
        heads = flipCoin(chump, house, winRate, lossRate)
        if heads : nHeads += 1
        side = ('tails','heads')[heads]
        bal1 = house.money
        bal2 = chump.money
        print("%5d %s %8.02f %8.02f" % (flip+1, side, bal1, bal2))
    print("")
    print("%03d heads in %d flips $%8.02f !" % (nHeads, nFlips, bal2))

if __name__ == "__main__" : 
    randomSeed() 
    games = sarg.Int("games",1)
    for i in range(games) : singlePlay()
